/*============================================================================
  File:     TempdbSetup.sql

  Summary:  Create some nasty tempdb waits

  SQL Server Versions: 2005 onwards
------------------------------------------------------------------------------
  Written by Paul S. Randal, SQLskills.com

  (c) 2013, SQLskills.com. All rights reserved.

  For more scripts and sample code, check out 
    http://www.SQLskills.com

  You may alter this code for your own *non-commercial* purposes. You may
  republish altered code as long as you include this copyright and give due
  credit, but you must obtain prior permission before blogging this code.
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

/*
-- Make sure extra tempdb files are removed
ALTER DATABASE tempdb
REMOVE FILE Tempdb2;
ALTER DATABASE tempdb
REMOVE FILE Tempdb3;
ALTER DATABASE tempdb
REMOVE FILE Tempdb4;

SELECT * FROM tempdb.sys.database_files;
*/

USE [master];
GO

IF DATABASEPROPERTYEX (N'TempdbTest', N'Version') > 0
BEGIN
	ALTER DATABASE [TempdbTest] SET SINGLE_USER
		WITH ROLLBACK IMMEDIATE;
	DROP DATABASE [TempdbTest];
END
GO

CREATE DATABASE [TempdbTest];
GO

USE [TempdbTest];
GO

CREATE TABLE [SampleTable] (
	[c1] INT IDENTITY);
GO

INSERT INTO [SampleTable] DEFAULT VALUES;
GO 10

-- In PerfMon, add Databases: Transactions/Sec for tempdb

-- Start 200 clients in batches of 50

SELECT * FROM sys.dm_os_waiting_tasks;
GO

-- Try adding another file
ALTER DATABASE [tempdb]
ADD FILE 
(
    NAME = [Tempdb2],
    FILENAME = N'C:\Program Files\Microsoft SQL Server\MSSQL10.MSSQLSERVER\MSSQL\DATA\tempdb2.ndf',
    SIZE = 25MB,
    MAXSIZE = 100MB,
    FILEGROWTH = 5MB
);
GO

-- Look at PerfMon

-- Now add two more files
ALTER DATABASE [tempdb]
ADD FILE 
(
    NAME = [Tempdb3],
    FILENAME = N'C:\Program Files\Microsoft SQL Server\MSSQL10.MSSQLSERVER\MSSQL\DATA\tempdb3.ndf',
    SIZE = 25MB,
    MAXSIZE = 100MB,
    FILEGROWTH = 5MB
);
GO
ALTER DATABASE [tempdb]
ADD FILE 
(
    NAME = [Tempdb4],
    FILENAME = N'C:\Program Files\Microsoft SQL Server\MSSQL10.MSSQLSERVER\MSSQL\DATA\tempdb4.ndf',
    SIZE = 25MB,
    MAXSIZE = 100MB,
    FILEGROWTH = 5MB
);
GO
